"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.verifyConfig = exports.handleUseApiOptions = exports.fetchApi = exports.reducer = exports.useApi = void 0;
var react_1 = require("react");
// import invariant from 'invariant'
var context_1 = require("./context");
var common_1 = require("./common");
exports.useApi = function (config, opt) {
    if (typeof config === 'string') {
        config = {
            url: config,
        };
    }
    var context = react_1.useContext(context_1.ApiContext);
    var _a = context.settings, cache = _a.cache, debug = _a.debug, shouldUseApiCache = _a.shouldUseApiCache, isSSR = context.isSSR, _b = context.collection, ssrConfigs = _b.ssrConfigs, cacheKeys = _b.cacheKeys;
    var cacheKey = JSON.stringify(config);
    var ref = react_1.useRef(react_1.useMemo(function () {
        return ({
            id: Date.now(),
            isRequesting: false,
            isFeeding: false,
            isInitialized: false,
            refreshFlag: 1,
            cacheKey: cacheKey,
            config: config,
        });
    }, []));
    var options = react_1.useMemo(function () { return exports.handleUseApiOptions(opt, cacheKey); }, [
        opt,
        cacheKey,
    ]);
    var refData = ref.current;
    var isValidConfig = exports.verifyConfig(config);
    var hasChangedConfig = refData.cacheKey !== cacheKey;
    if (hasChangedConfig) {
        refData.cacheKey = cacheKey;
        refData.config = config;
    }
    // SSR processing
    var cacheData = cache.get(cacheKey);
    var skip = options.skip;
    var defaultState = __assign({}, common_1.initState);
    if (!skip) {
        if (cacheData && (isSSR || !!shouldUseApiCache(config, cacheKey))) {
            var response = cacheData.response, error = cacheData.error;
            var action = {
                type: common_1.ACTIONS.REQUEST_END,
                response: response,
                error: error,
                options: options,
            };
            debug && console.log('[ReactUseApi][Feed]', cacheKey);
            if (!isSSR) {
                action.fromCache = true;
                refData.isFeeding = true;
            }
            defaultState = exports.reducer(defaultState, action);
        }
        else if (isSSR) {
            if (!cacheKeys.has(cacheKey)) {
                cacheKeys.add(cacheKey);
                debug && console.log('[ReactUseApi][Collect]', cacheKey);
            }
            ssrConfigs.push({
                config: config,
                cacheKey: cacheKey,
            });
        }
    }
    var _c = react_1.useReducer(exports.reducer, defaultState), state = _c[0], dispatch = _c[1];
    var shouldRequest = options.shouldRequest, watch = options.watch;
    var loading = state.loading, data = state.data;
    var request = react_1.useCallback(function (cfg, keepState) {
        if (cfg === void 0) { cfg = refData.config; }
        if (keepState === void 0) { keepState = false; }
        return __awaiter(void 0, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                if (options.skip) {
                    return [2 /*return*/, null];
                }
                // foolproof
                if (((_a = cfg) === null || _a === void 0 ? void 0 : _a.target) && ((_b = cfg) === null || _b === void 0 ? void 0 : _b.isDefaultPrevented)) {
                    cfg = refData.config;
                }
                // update state's cachekey for saving the prevState when requesting (refreshing)
                // it's good to set true for pagination
                if (keepState) {
                    state.$cacheKey = cacheKey;
                }
                refData.isRequesting = true;
                return [2 /*return*/, exports.fetchApi(context, cfg, options, dispatch)];
            });
        });
    }, [context, cacheKey, options, dispatch, state, refData]);
    var shouldFetchApi = react_1.useCallback(function (forRerender) {
        if (forRerender === void 0) { forRerender = false; }
        var shouldRequestResult;
        if (common_1.isFunction(shouldRequest)) {
            shouldRequestResult = !!shouldRequest();
        }
        return (!skip &&
            !refData.isRequesting &&
            (forRerender
                ? shouldRequestResult === true
                : shouldRequestResult !== false) // false means skip
        );
    }, [skip, refData, shouldRequest]);
    // for each re-rendering
    if (shouldFetchApi(true)) {
        refData.refreshFlag = Date.now();
    }
    if (!loading && refData.isRequesting) {
        refData.isRequesting = false;
    }
    var useIsomorphicLayoutEffect = isSSR ? react_1.useEffect : react_1.useLayoutEffect;
    var effect = react_1.useCallback(function (callback) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var wrapper = function () {
            if (isValidConfig) {
                return callback();
            }
        };
        return useIsomorphicLayoutEffect.apply(void 0, __spreadArrays([wrapper], args));
    }, [isValidConfig]);
    effect(function () {
        // SSR will never invoke request() due to the following cases:
        // 1. There is a cacheData for the cacheKey
        // 2. Feeding the data come from the cache
        // For non-SSR, cacheData will be undefined if cacheKey has been changed
        if (!isSSR && !cacheData && !refData.isFeeding) {
            request();
        }
        if (refData.isFeeding) {
            refData.isFeeding = false;
        }
    }, __spreadArrays([cacheKey, refData.refreshFlag], (Array.isArray(watch) ? watch : [])));
    if (!isValidConfig) {
        return [undefined, undefined, undefined];
    }
    return [data, state, request];
};
exports.reducer = function (state, action) {
    var type = action.type, options = action.options;
    var cacheKey = options.$cacheKey;
    var basicState = {
        $cacheKey: cacheKey,
    };
    switch (type) {
        case common_1.ACTIONS.REQUEST_START: {
            return __assign(__assign(__assign({}, (cacheKey !== state.$cacheKey ? common_1.initState : state)), { loading: true, error: undefined, fromCache: false }), basicState);
        }
        case common_1.ACTIONS.REQUEST_END: {
            var response = action.response, error = action.error, fromCache = action.fromCache;
            var pre = state.prevState, prevState = __rest(state, ["prevState"]);
            var prevData = prevState.data;
            var dependencies = options.dependencies;
            var newState = __assign(__assign(__assign({}, prevState), { prevData: prevData,
                prevState: prevState, loading: false, response: response,
                dependencies: dependencies,
                error: error, fromCache: !!fromCache }), basicState);
            newState.data = error ? undefined : common_1.getResponseData(options, newState);
            return newState;
        }
        default:
            return state;
    }
};
exports.fetchApi = function (context, config, options, dispatch) { return __awaiter(void 0, void 0, void 0, function () {
    var cache, cacheKey, _a, response, error, error_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                cache = context.settings.cache;
                cacheKey = options.$cacheKey;
                _b.label = 1;
            case 1:
                _b.trys.push([1, 5, , 6]);
                _a = cache.get(cacheKey) || {}, response = _a.response, error = _a.error;
                if (!(response || error)) return [3 /*break*/, 2];
                cache.del(cacheKey);
                return [3 /*break*/, 4];
            case 2:
                dispatch({ type: common_1.ACTIONS.REQUEST_START, options: options });
                return [4 /*yield*/, common_1.axiosAll(context, config)];
            case 3:
                response = _b.sent();
                _b.label = 4;
            case 4:
                dispatch({ type: common_1.ACTIONS.REQUEST_END, response: response, error: error, options: options });
                return [3 /*break*/, 6];
            case 5:
                error_1 = _b.sent();
                dispatch({
                    type: common_1.ACTIONS.REQUEST_END,
                    error: error_1,
                    options: options,
                });
                return [3 /*break*/, 6];
            case 6: return [2 /*return*/];
        }
    });
}); };
exports.handleUseApiOptions = function (opt, cacheKey) {
    var options = common_1.isObject(opt)
        ? __assign({}, opt)
        : {
            watch: Array.isArray(opt) ? opt : [],
            handleData: common_1.isFunction(opt) ? opt : undefined,
        };
    options.$cacheKey = cacheKey;
    return options;
};
exports.verifyConfig = function (config) {
    return common_1.isObject(config)
        ? !!config.url
        : Array.isArray(config)
            ? config.every(function (each) { return !!each.url; })
            : false;
};
exports.default = exports.useApi;
//# sourceMappingURL=useApi.js.map